=== debian/changelog ===
weave (1.4.3-1ubuntu2) maverick; urgency=low

  * No source change rebuild to pick up mozilla-devscripts changes; Drop 
    transitional and removed packages from Recommends (LP: #645339) 

 -- Micah Gersten <micahg@ubuntu.com>  Sun, 26 Sep 2010 19:57:30 -0500

weave (1.4.3-1ubuntu1) maverick; urgency=low

  * Add -fshort-wchar to CXXFLAGS to fix FTBFS in Ubuntu
    - update debian/rules 

 -- Micah Gersten <micahg@ubuntu.com>  Wed, 11 Aug 2010 00:35:15 -0500

weave (1.4.3-1) unstable; urgency=low

  [ Fladischer Michael ]
  * Rename debian/NEWS.Debian -> debian/NEWS (Closes: #588239).

  [ Alexander GQ Gerasiov ]
  * Imported Upstream version 1.4.1
  * debian/control: Bump standard's version. No changes needed.

  [ Fladischer Michael ]
  * Add VSC-* fields.

  [ Alexander GQ Gerasiov ]
  * Imported Upstream version 1.4.3

 -- Alexander GQ Gerasiov <gq@debian.org>  Tue, 03 Aug 2010 14:40:37 +0400

weave (1.4-1) unstable; urgency=low

  [ Fladischer Michael ]
  * Fixed some typos in README.source.
  * debian/clean: removed.
  * debian/rules, debian/README.source: Upstream repository URL has changed.
  * debian/NEWS: Add NEWS regarding the status bar.

  [ Alexander GQ Gerasiov ]
  * Imported Upstream version 1.4
  * debian/crypto.Makefile: subst fixed according to changes in top-level
    Makefile

 -- Alexander GQ Gerasiov <gq@debian.org>  Mon, 05 Jul 2010 13:28:38 +0400

weave (1.3-2) unstable; urgency=low

  * debian/control: Bynary package renamed to xul-ext-sync according to
    Weave's rebranding to Firefox sync.
  * debian/control: Description updated.
  * debian/README.source: More clear (but may be worse-written)
    description.

 -- Alexander GQ Gerasiov <gq@debian.org>  Mon, 07 Jun 2010 22:49:12 +0400

weave (1.3-1) unstable; urgency=low

  [ Fladischer Michael ]
  * Initial release (Closes: #556135)

  [ Alexander GQ Gerasiov ]
  * debian/control: Set Maintainer to pkg-mozext-team.
  * debian/control: Dependences fixed.
  * debian/patches/fix_crypto_makefile removed. Using own Makefile
    instead.
  * debian/patches/fix_chrome_jar removed. Modified
    MOZ_XPI_BUILD_COMMAND instead.
  * debian/rules: Rewriten with usage on standard CDBS variables instead
    of own ones.

 -- Alexander GQ Gerasiov <gq@debian.org>  Mon, 07 Jun 2010 00:17:27 +0400
