=== debian/control ===
Source: weave
Section: web
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Mozilla Extension Maintainers <pkg-mozext-maintainers@lists.alioth.debian.org>
Uploaders: Fladischer Michael <FladischerMichael@fladi.at>, Alexander GQ Gerasiov <gq@debian.org>
Build-Depends: cdbs, debhelper (>= 7), xulrunner-dev (>= 1.9~), mozilla-devscripts (>= 0.16~), pkg-config
Standards-Version: 3.9.0
Homepage: https://mozillalabs.com/weave/
VCS-Browser: http://git.debian.org/?p=pkg-mozext/weave.git;a=summary
VCS-Git: git://git.debian.org/pkg-mozext/weave.git

Package: xul-ext-sync
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ${xpi:Recommends}
Enhances: ${xpi:Enhances}
Provides: ${xpi:Provides}
Description: extension to sync bookmarks, passwords and other user data between devices
 It is an add-on which allows you to synchronize browser-related personal
 information (such as bookmarks, history, saved passwords, open tabs) to a
 server and all your devices.
 .
 It can be used with Mozilla's server, or you can set up your own as well.
