=== debian/rules ===
#!/usr/bin/make -f

MOZ_XPI_BUILD_COMMAND := make crypto&&make crypto-obsolete-build&&make xpi release_build=1
MOZ_XPI_FILE = dist/xpi/weave-$(DEB_UPSTREAM_VERSION)-rel.xpi

#Build variables
export XULRUNNER_BIN := $(firstword $(wildcard /usr/bin/xulrunner-*))
export MOZSDKDIR := $(shell pkg-config --variable=sdkdir libxul)
export TOPSRCDIR := $(CURDIR)
export WEAVE_BUILDID := $(DEB_VERSION)

CXXFLAGS += -fshort-wchar

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/mozilla-devscripts/xpi.mk

pre-build::
	test -f crypto-obsolete/src/Makefile.upstream || mv crypto-obsolete/src/Makefile crypto-obsolete/src/Makefile.upstream
	cp debian/crypto.Makefile crypto-obsolete/src/Makefile

clean::
	make clean
	rm -rf crypto-obsolete/platform/*
	make -C crypto-obsolete/src clean
	! test -f crypto-obsolete/src/Makefile.upstream || mv crypto-obsolete/src/Makefile.upstream crypto-obsolete/src/Makefile


UPSTREAM_TARBALL := ../$(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.tar.bz2

get-orig-source:
	test ! -f $(UPSTREAM_TARBALL)
	rm -rf get-orig-source
	mkdir get-orig-source
	hg clone -u $(DEB_UPSTREAM_VERSION) http://hg.mozilla.org/services/fx-sync/ \
	get-orig-source/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION).orig
	rm -rf get-orig-source/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION).orig/crypto-obsolete/platform/*
	tar -c -j --exclude ".hg*" -f $(UPSTREAM_TARBALL) -C get-orig-source $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION).orig
	rm -rf get-orig-source

.PHONY: get-orig-source
